//===================================================================
// asb3000s.pas
//-------------------------------------------------------------------
//
// ASB-3000 Sample
//
//-------------------------------------------------------------------
// CH1CALM͂AgKʒȗÕf[^\܂B
//===================================================================
unit asb3000s;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, asb3000w, StdCtrls;

const
	WM_ASB3000_BASE				= WM_USER + 100;
  WM_ASB3000_DATA_READY = WM_ASB3000_BASE + WM_DATA_READY;
  WM_ASB3000_ERROR			= WM_ASB3000_BASE + WM_DATA_THREAD_ERROR;
  szTitle								= 'Sample';

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private 錾 }
    mwDeviceNo: Word;
    mpdwADData: array of DWord;
    mSetMode:   TSETMODE;

    function  VoltValue(addata: DWord): Extended;
    procedure ResultMessage(szbuf: String);
    procedure ErrorMessage(devno: Word);
  public
    { Public 錾 }
  protected
  	procedure DataReady(var Msg: TMessage); message WM_ASB3000_DATA_READY;
    procedure DataThreadError(var Msg: TMessage); message WM_ASB3000_ERROR;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

//-------------------------------------------------------------------
// 
//-------------------------------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
var
	szbuf:		 String;
  dwDrvVer:	 DWord;
  dwDllVer:	 DWord;
  dwMemSize: DWord;
  DevInfo:	 TDEVINFO;
begin
	//------------------------------------------------------------
  // DLL̎gp錾
  //------------------------------------------------------------
  if Asb3000wDllOpen = False then
  	ErrorMessage(ASB3000_DEVICE_AUTO);
  //------------------------------------------------------------
  // foCX̎gp錾
  //------------------------------------------------------------
  mwDeviceNo := ASB3000_DEVICE_AUTO;
  if Asb3000wCreate(mwDeviceNo, Handle, WM_ASB3000_BASE) = False then
  	ErrorMessage(ASB3000_DEVICE_AUTO);
  szbuf := Format('foCX %d ̎gp錾܂B', [mwDeviceNo]);
  ResultMessage(szbuf);
  //------------------------------------------------------------
  // o[W擾
  //------------------------------------------------------------
  if Asb3000wGetVersion(dwDrvVer, dwDllVer) = False then
  	ErrorMessage(ASB3000_DEVICE_AUTO);
  szbuf := Format('o[W'#10 +
  								'   Driver Version : %.8xH'#10 +
                  '   DLL Version : %.8xH',
                  [dwDrvVer, dwDllVer]);
  ResultMessage(szbuf);
  //------------------------------------------------------------
  // foCX擾
  //------------------------------------------------------------
  if Asb3000wGetDevInfo(mwDeviceNo, DevInfo) = False then
  	ErrorMessage(mwDeviceNo);
  szbuf := Format('foCX'#10 +
  								'   Firm Version : %.2f'#10 +
                  '   FPGA Version : %.2f',
                  [(DevInfo.FirmVer div 100) + (DevInfo.FirmVer mod 100) * 0.01,
                   (DevInfo.FpgaVer div 100) + (DevInfo.FpgaVer mod 100) * 0.01]);
  ResultMessage(szbuf);
  //------------------------------------------------------------
  // TCY擾
  //------------------------------------------------------------
  if Asb3000wGetMemSize(mwDeviceNo, dwMemSize) = False then
  	ErrorMessage(mwDeviceNo);
  if dwMemSize = 0 then szbuf := '128K|Cg'
  else szbuf := '1M|Cg';
  ResultMessage('TCY'#10 + '   ' + szbuf);
  //------------------------------------------------------------
  // TvO샂[hݒ
  //------------------------------------------------------------
  // ݒ
  mSetMode.dwVoltDiv[ASB3000_CH1]      := ASB3000_VOLTDIV_1;			// XP[
  mSetMode.dwVoltDiv[ASB3000_CH2]      := ASB3000_VOLTDIV_1;
  mSetMode.dwVoltPos[ASB3000_CH1]      := 100;										// |WV
  mSetMode.dwVoltPos[ASB3000_CH2]      := 100;
  mSetMode.dwVertCoupling[ASB3000_CH1] := ASB3000_CUP_DC;					// ͌
  mSetMode.dwVertCoupling[ASB3000_CH2] := ASB3000_CUP_DC;
  // ݒ
  mSetMode.dwMemSize                   := ASB3000_MEMSIZE_10K;		// TCY
  mSetMode.dwSamplingTime              := ASB3000_TIMEDIV_200NS;	// XP[
  mSetMode.dwBandWidth[ASB3000_CH1]    := ASB3000_BW_FULL;				// gш
  mSetMode.dwBandWidth[ASB3000_CH2]    := ASB3000_BW_FULL;
  mSetMode.dwSamplingMode              := ASB3000_SMP_REAL;				// TvO[h
  mSetMode.dwAcqMode                   := ASB3000_ACQ_SINGLE;			// ANCWV[h
  // gKݒ
  mSetMode.dwTrigMode                  := ASB3000_TMODE_AUTO;			// gK[h
  mSetMode.dwTrigSource                := ASB3000_TSRC_CH1;				// gK\[X
  mSetMode.dwTrigCoupling              := ASB3000_TCUP_DC;				// gK͌
  mSetMode.dwTrigSlope                 := ASB3000_TSLP_POS;				// gKX[v
  mSetMode.dwTrigLevel                 := 250;										// gKx
  mSetMode.dwTrigPos                   := 5000;										// gK|WV
  mSetMode.dwTrigDelay                 := 0;											// gKfBC
  mSetMode.dwTrigPulse                 := ASB3000_PULSE_NONE;			// pXgK(pX)
  mSetMode.dwTrigPulseWidth            := 0;											// pXgK(pX)
  if Asb3000wSetMode(mwDeviceNo, mSetMode) = False then
  	ErrorMessage(mwDeviceNo);
  szbuf := Format('TvO샂[hݒ'#10 +
  								' yݒz'#10 +
                  '   CH1 XP[ : %d'#10 +
                  '   CH2 XP[ : %d'#10 +
                  '   CH1 |WV : %d'#10 +
                  '   CH2 |WV : %d'#10 +
                  '   CH1 ͌ : %d'#10 +
                  '   CH2 ͌ : %d'#10 +
                  ' yݒz'#10 +
                  '   TCY : %d'#10 +
                  '   TvO^C : %d'#10 +
                  '   CH1 gш : %d'#10 +
                  '   CH2 gш : %d'#10 +
                  '   TvO[h : %d'#10 +
                  '   ANCWV[h : %d'#10 +
                  ' ygKݒz'#10 +
                  '   [h : %d'#10 +
                  '   \[X : %d'#10 +
                  '   ͌ : %d'#10 +
                  '   X[v : %d'#10 +
                  '   x : %d'#10 +
                  '   |WV : %d'#10 +
                  '   fBC : %d'#10 +
                  '   pX : %d'#10 +
                  '   pX : %d',
                  [mSetMode.dwVoltDiv[ASB3000_CH1],
                   mSetMode.dwVoltDiv[ASB3000_CH2],
                   mSetMode.dwVoltPos[ASB3000_CH1],
                   mSetMode.dwVoltPos[ASB3000_CH2],
                   mSetMode.dwVertCoupling[ASB3000_CH1],
                   mSetMode.dwVertCoupling[ASB3000_CH2],
                   mSetMode.dwMemSize,
                   mSetMode.dwSamplingTime,
                   mSetMode.dwBandWidth[ASB3000_CH1],
                   mSetMode.dwBandWidth[ASB3000_CH2],
                   mSetMode.dwSamplingMode,
                   mSetMode.dwAcqMode,
                   mSetMode.dwTrigMode,
                   mSetMode.dwTrigSource,
                   mSetMode.dwTrigCoupling,
                   mSetMode.dwTrigSlope,
                   mSetMode.dwTrigLevel,
                   mSetMode.dwTrigPos,
                   mSetMode.dwTrigDelay,
                   mSetMode.dwTrigPulse,
                   mSetMode.dwTrigPulseWidth]);
  ResultMessage(szbuf);
  //------------------------------------------------------------
  // TvOJn
  //------------------------------------------------------------
  ResultMessage('TvOJn܂B');
  if Asb3000wStartSampling(mwDeviceNo, 0) = False then
  	ErrorMessage(mwDeviceNo);
end;
//-------------------------------------------------------------------
// I
//-------------------------------------------------------------------
procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	//------------------------------------------------------------
  // foCX̎gpJ
  //------------------------------------------------------------
  if Asb3000wClose(mwDeviceNo) = False then
  	ErrorMessage(mwDeviceNo);
  ResultMessage('foCXJ܂B');
  //------------------------------------------------------------
  // DLL̎gpJ
  //------------------------------------------------------------
  if Asb3000wDllClose = False then
  	MessageBox(Handle, PChar('asb3000.dll ̃A[hɎs܂B'),
    					 szTitle, MB_OK + MB_ICONSTOP);
end;
//-------------------------------------------------------------------
// TvOf[^
//-------------------------------------------------------------------
procedure TForm1.DataReady(var Msg: TMessage);
var
	szbuf:		 String;
  wDevNo:		 Word;
  dwStatus:	 DWord;
  dwNumData: DWord;
  dwInitArg: DWord;
  dwData:		 DWord;
  i:				 Integer;
begin
	if Msg.LParam <> ASB3000_DEVICE_ID then Exit;
  wDevNo := Word(Msg.WParam);
  //------------------------------------------------------------
  // TvO~
  //------------------------------------------------------------
  if Asb3000wStopSampling(wDevNo) = False then
  	ErrorMessage(wDevNo);
  ResultMessage('TvO~܂B');
  //------------------------------------------------------------
  // TvOXe[^X擾
  //------------------------------------------------------------
  if Asb3000wGetStatus(wDevNo, dwStatus, dwNumData, dwInitArg) = False then
  	ErrorMessage(wDevNo);
  szbuf := Format('TvOXe[^X擾'#10 +
  								'   TvOXe[^X : %xH'#10 +
                  '   ǃTvOf[^ : %d',
                  [dwStatus, dwNumData]);
  ResultMessage(szbuf);
  //------------------------------------------------------------
  // TvOf[^擾
  //------------------------------------------------------------
  if dwNumData > 0 then begin
  	SetLength(mpdwADData, dwNumData);
    if Asb3000wGetData(wDevNo, dwNumData, mpdwADData[0]) = False then
    	ErrorMessage(wDevNo);
    szbuf := Format('TvOf[^ %d 擾܂B'#10#10 +
    								'CH1 擾f[^'#10,
                    [dwNumData]);
    for i := 4990 to 5010 do begin	// 擾f[^\
    	dwData := mpdwADData[i] and ADDATA_MASK_BIT;					// CH1
      //dwData := (mpdwADData[i] shr 16) and ADDATA_MASK_BIT;	// CH2
      szbuf := szbuf + Format('   %d : %d ( %.2f )'#10,
      												[i, dwData, VoltValue(dwData)]);
    end;
    szbuf := szbuf + Format(#10' gKʒu : %d ̑O10\'#10 +
    												'@@JbR͓dl(PmV)',
                            [mSetMode.dwTrigPos]);
    ResultMessage(szbuf);
  end;
  //------------------------------------------------------------
  // I
  //------------------------------------------------------------
  Close;
end;
//-------------------------------------------------------------------
// dlZ
//-------------------------------------------------------------------
function TForm1.VoltValue(addata: DWord): Extended;
var
	voltdiv: DWord;
  vfull:	 Extended;
begin
	// Volt/div
  case mSetMode.dwVoltDiv[ASB3000_CH1] of
  	ASB3000_VOLTDIV_0: voltdiv := 10;
    ASB3000_VOLTDIV_1: voltdiv := 20;
    ASB3000_VOLTDIV_2: voltdiv := 50;
    ASB3000_VOLTDIV_3: voltdiv := 100;
    ASB3000_VOLTDIV_4: voltdiv := 200;
    ASB3000_VOLTDIV_5: voltdiv := 500;
    ASB3000_VOLTDIV_6: voltdiv := 1000;
    ASB3000_VOLTDIV_7: voltdiv := 2000;
    else voltdiv := 0;
  end;
  // tXP[d(v[u10:1)
  vfull := voltdiv * ASB3000_PROBE_X10 * 10;
  // dlɊZ
  Result := (vfull * addata / ASB3000_RES_VERT)
  				- (vfull * mSetMode.dwVoltPos[ASB3000_CH1] / ASB3000_RES_VOLTPOS);
end;
//-------------------------------------------------------------------
// TvOf[^擾pXbhG[
//-------------------------------------------------------------------
procedure TForm1.DataThreadError(var Msg: TMessage);
begin
  if Msg.LParam = ASB3000_DEVICE_ID then ErrorMessage(Word(Msg.WParam));
end;
//-------------------------------------------------------------------
// ʂ\
//-------------------------------------------------------------------
procedure TForm1.ResultMessage(szbuf: String);
begin
  MessageBox(Handle, PChar(szbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//-------------------------------------------------------------------
// G[bZ[W\
//-------------------------------------------------------------------
procedure TForm1.ErrorMessage(devno: Word);
var
	dwRes: DWord;
  szbuf: String;
begin
	dwRes := Asb3000wGetLastError(devno);
  if dwRes = ASB3000_ERR_WRAPDLL then szbuf := 'DLL Load error'
  else szbuf := Format('ASB-3000 error'#10#10'Error code : %.8xH',[dwRes]);

  MessageBox(Handle, PChar(szbuf), szTitle, MB_OK + MB_ICONSTOP);
  Halt;
end;

end.
