//===================================================================
// asb3000s.h
//-------------------------------------------------------------------
//
// ASB-3000 Sample
//
//-------------------------------------------------------------------
// CH1CALM͂AgKʒȗÕf[^\܂B
//===================================================================

#pragma once

#include <windows.h>
#include "Asb3000w.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;

#ifdef MessageBox
#undef MessageBox
#endif

namespace SampleAsb3000
{
	/// <summary> 
	/// Asb3000s ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB 
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Asb3000s : public System::Windows::Forms::Form
	{
	public: 
		Asb3000s(void)
		{
			InitializeComponent();
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}

		//-------------------------------------------------------------------
		// bZ[W̏
		//-------------------------------------------------------------------
		#define WM_ASB3000_BASE			WM_USER + 100
		#define WM_ASB3000_DATA_READY	WM_ASB3000_BASE + Asb3000::WM_DATA_READY
		#define WM_ASB3000_ERROR		WM_ASB3000_BASE + Asb3000::WM_DATA_THREAD_ERROR

		void WndProc(System::Windows::Forms::Message __gc * m)
		{
			switch ( m->Msg ) {
				case WM_ASB3000_DATA_READY:
					DataReady( m->WParam, m->LParam );
					break;
				case WM_ASB3000_ERROR:
					DataThreadError( m->WParam, m->LParam );
					break;
			}
			Form::WndProc(m);
		}

	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container* components;

		static Asb3000				*Asb3000w;
		static Asb3000::TSETMODE	*mSetMode;
		static short				mwDeviceNo;

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			// 
			// Asb3000s
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = S"Asb3000s";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"ASB-3000 Sample";
			this->Load += new System::EventHandler(this, Asb3000s_Load);
			this->Closed += new System::EventHandler(this, Asb3000s_Closed);

		}		

		
		//-------------------------------------------------------------------
        // 
        //-------------------------------------------------------------------
	private: System::Void Asb3000s_Load(System::Object *  sender, System::EventArgs *  e)
			 {
                 int i;
                 int dwDrvVer, dwDllVer, dwMemSize, hwnd;
                 short wDeviceNo;
                 String* szbuf;
                 Asb3000::TDEVINFO* DevInfo;

                 //------------------------------------------------------------
                 // 
                 //------------------------------------------------------------
                 Asb3000w = new Asb3000();
                 mSetMode = new Asb3000::TSETMODE();
                 mSetMode->dwVoltDiv      = new Int32[Asb3000::NUM_CH];
                 mSetMode->dwVoltPos      = new Int32[Asb3000::NUM_CH];
                 mSetMode->dwVertCoupling = new Int32[Asb3000::NUM_CH];
                 mSetMode->dwBandWidth    = new Int32[Asb3000::NUM_CH];
                 DevInfo  = new Asb3000::TDEVINFO();
                 DevInfo->VendorID  = new Byte[Asb3000::VID_LENGTH];
                 DevInfo->ProductID = new Byte[Asb3000::PID_LENGTH];
                 for ( i = 0 ; i < Asb3000::VID_LENGTH; i++ )
                     DevInfo->VendorID[i] = 0;
                 for ( i = 0 ; i < Asb3000::PID_LENGTH; i++ )
                     DevInfo->ProductID[i] = 0;
                 DevInfo->FirmVer = 0;
                 DevInfo->FpgaVer = 0;
                 //------------------------------------------------------------
                 // foCX̎gp錾
                 //------------------------------------------------------------
                 wDeviceNo = Asb3000::DEVICE_AUTO;
                 hwnd = this->Handle.ToInt32();			// EChEnh
                 if ( false == Asb3000w->Create( &wDeviceNo, hwnd, WM_ASB3000_BASE ) ) {
                     ErrorMessage( Asb3000::DEVICE_AUTO );
                     return;
                 }
                 szbuf = String::Format( S"foCX {0} ̎gp錾܂B", wDeviceNo.ToString() );
                 ResultMessage( szbuf );
                 mwDeviceNo = wDeviceNo;
                 //------------------------------------------------------------
                 // o[W擾
                 //------------------------------------------------------------
                 if ( false == Asb3000::GetVersion( &dwDrvVer, &dwDllVer ) ) {
                     ErrorMessage( Asb3000::DEVICE_AUTO );
                     return;
                 }
                 szbuf = String::Concat( S"o[W\n",
                                         String::Format(S"   DRV Version : 0x{0}\n", 
                                                            dwDrvVer.ToString("x8")),
                                         String::Format(S"   DLL Version : 0x{0}",
                                                            dwDllVer.ToString("x8")) );
                 ResultMessage( szbuf );
                 //------------------------------------------------------------
                 // foCX擾
                 //------------------------------------------------------------
                 if ( false == Asb3000w->GetDevInfo( mwDeviceNo, DevInfo ) ) {
                     ErrorMessage( mwDeviceNo );
                     return;
                 }
                 szbuf = String::Concat( S"foCX",
                                            S"\n   Firm Version : ", 
                                                (DevInfo->FirmVer / 100.0).ToString("f2"), 
                                            S"\n   FPGA Version : ", 
                                                (DevInfo->FpgaVer / 100.0).ToString("f2") );
                 ResultMessage( szbuf );
                 //------------------------------------------------------------
                 // TCY擾
                 //------------------------------------------------------------
                 if ( false == Asb3000w->GetMemSize( mwDeviceNo, &dwMemSize ) ) {
                     ErrorMessage( mwDeviceNo );
                     return;
                 }
                 szbuf = String::Copy( S"TCY\n" );
                 if ( 0 == dwMemSize ) {
                     szbuf = String::Concat( szbuf, "   128K|Cg" );
                 }
                 else {
                     szbuf = String::Concat( szbuf, "   1M|Cg" );
                 }
                 ResultMessage( szbuf );
                 //------------------------------------------------------------
                 // TvO샂[h()ݒ
                 //------------------------------------------------------------
                 mSetMode->dwVoltDiv[ Asb3000::CH1 ]      = Asb3000::VOLTDIV_1;		// XP[
                 mSetMode->dwVoltDiv[ Asb3000::CH2 ]      = Asb3000::VOLTDIV_1;
                 mSetMode->dwVoltPos[ Asb3000::CH1 ]      = 100;					// |WV
                 mSetMode->dwVoltPos[ Asb3000::CH2 ]      = 100;
                 mSetMode->dwVertCoupling[ Asb3000::CH1 ] = Asb3000::CUP_DC;		// ͌
                 mSetMode->dwVertCoupling[ Asb3000::CH2 ] = Asb3000::CUP_DC;
                 //------------------------------------------------------------
                 // TvO샂[h()ݒ
                 //------------------------------------------------------------
                 mSetMode->dwMemSize                   = Asb3000::MEMSIZE_10K;		// TCY
                 mSetMode->dwSamplingTime              = Asb3000::TIMEDIV_200NS;	// XP[
                 mSetMode->dwBandWidth[ Asb3000::CH1 ] = Asb3000::BW_FULL;			// gш
                 mSetMode->dwBandWidth[ Asb3000::CH2 ] = Asb3000::BW_FULL;
                 mSetMode->dwSamplingMode              = Asb3000::SMP_REAL;			// TvO[h
                 mSetMode->dwAcqMode                   = Asb3000::ACQ_SINGLE;		// ANCWV[h
                 //------------------------------------------------------------
                 // TvO샂[h(gK)ݒ
                 //------------------------------------------------------------
                 mSetMode->dwTrigMode		= Asb3000::TMODE_AUTO;				// gK[h
                 mSetMode->dwTrigSource		= Asb3000::TSRC_CH1;				// gK\[X
                 mSetMode->dwTrigCoupling	= Asb3000::TCUP_DC;					// gK͌
                 mSetMode->dwTrigSlope		= Asb3000::TSLP_POS;				// gKX[v
                 mSetMode->dwTrigLevel		= 250;								// gKx
                 mSetMode->dwTrigPos		= 5000;								// gK|WV
                 mSetMode->dwTrigDelay		= 0;								// gKfBC
                 mSetMode->dwTrigPulse		= Asb3000::PULSE_NONE;				// pXgK(pX)
                 mSetMode->dwTrigPulseWidth	= 0;								// pXgK(pX)
                 if ( false == Asb3000w->SetMode( mwDeviceNo, mSetMode ) ) {
                     ErrorMessage( mwDeviceNo );
                     return;
                 }
                 szbuf = String::Concat( S"TvO샂[hݒ",
                                         S"\n yݒz",
                                         S"\n   CH1 XP[ : ",			mSetMode->dwVoltDiv[ Asb3000::CH1 ].ToString(),
                                         S"\n   CH2 XP[ : ",			mSetMode->dwVoltDiv[ Asb3000::CH2 ].ToString(),
                                         S"\n   CH1 |WV : ",			mSetMode->dwVoltPos[ Asb3000::CH1 ].ToString(),
                                         S"\n   CH2 |WV : ",			mSetMode->dwVoltPos[ Asb3000::CH2 ].ToString(),
                                         S"\n   CH1 ͌ : ",			mSetMode->dwVertCoupling[ Asb3000::CH1 ].ToString(),
                                         S"\n   CH2 ͌ : ",			mSetMode->dwVertCoupling[ Asb3000::CH2 ].ToString(),
                                         S"\n yݒz",
                                         S"\n   TCY : ",			mSetMode->dwMemSize.ToString(),
                                         S"\n   TvO^C : ",		mSetMode->dwSamplingTime.ToString(),
                                         S"\n   CH1 gш : ",			mSetMode->dwBandWidth[ Asb3000::CH1 ].ToString(),
                                         S"\n   CH2 gш : ",			mSetMode->dwBandWidth[ Asb3000::CH2 ].ToString(),
                                         S"\n   TvO[h : ",		mSetMode->dwSamplingMode.ToString(),
                                         S"\n   ANCWV[h : ",	mSetMode->dwAcqMode.ToString(),
                                         S"\n ygKݒz",
                                         S"\n   [h : ",					mSetMode->dwTrigMode.ToString(),
                                         S"\n   \[X : ",					mSetMode->dwTrigSource.ToString(),
                                         S"\n   ͌ : ",				mSetMode->dwTrigCoupling.ToString(),
                                         S"\n   X[v : ",				mSetMode->dwTrigSlope.ToString(),
                                         S"\n   x : ",					mSetMode->dwTrigLevel.ToString(),
                                         S"\n   |WV : ",				mSetMode->dwTrigPos.ToString(),
                                         S"\n   fBC : ",				mSetMode->dwTrigDelay.ToString(),
                                         S"\n   pX : ",			mSetMode->dwTrigPulse.ToString(),
                                         S"\n   pX : ",				mSetMode->dwTrigPulseWidth.ToString() );
                 ResultMessage( szbuf );
                 //------------------------------------------------------------
                 // TvOJn
                 //------------------------------------------------------------
                 ResultMessage( S"TvOJn܂B" );
                 if ( false == Asb3000w->StartSampling( mwDeviceNo, 0 ) ) {
                     ErrorMessage( mwDeviceNo );
                     return;
                 }
             }

             //-------------------------------------------------------------------
             // I
             //-------------------------------------------------------------------
	private: System::Void Asb3000s_Closed(System::Object *  sender, System::EventArgs *  e)
			 {
                 // foCX̎gpJ
                 if ( false == Asb3000w->Close( mwDeviceNo ) )
                     ErrorMessage( mwDeviceNo );
                 ResultMessage( "foCXJ܂B" );
			 }

             //-------------------------------------------------------------------
             // `f[^
             //-------------------------------------------------------------------
	private: void DataReady( IntPtr wParam, IntPtr lParam )
			 {
                 String* szbuf;
                 String* sztmp;
                 short wDevNo;
                 double dblData;
                 int* pdwAdData;
                 int i, dwData, dwStatus, dwNumData, dwInitArg;

                 if ( Asb3000::DEVICE_ID != lParam.ToInt32() )
                     return;
                 wDevNo = (short)wParam.ToInt32();
                 //------------------------------------------------------
                 // TvO~
                 //------------------------------------------------------
                 if ( false == Asb3000w->StopSampling( wDevNo ) ) {
                     ErrorMessage( wDevNo );
                  }
                 ResultMessage( "TvO~܂B" );
                 //------------------------------------------------------
                 // TvOXe[^X擾
                 //------------------------------------------------------
                 if ( false == Asb3000w->GetStatus( wDevNo, &dwStatus, &dwNumData, &dwInitArg ) ) {
                     ErrorMessage( wDevNo );
                     return;
                 }
                 szbuf = String::Concat( S"TvOXe[^X擾", 
                                         S"\n   TvOXe[^X : 0x", dwStatus.ToString("x"),
                                         S"\n   ǃTvOf[^ : ", dwNumData.ToString() );
                 ResultMessage( szbuf );
                 //------------------------------------------------------
                 // TvOf[^擾
                 //------------------------------------------------------
                 if ( dwNumData == 0 )
                     return;
                 pdwAdData = (int*)malloc( dwNumData * sizeof( int ) );
                 if ( pdwAdData == NULL ) {
                     ResultMessage( "obt@mۂł܂ł" );
                     return;
                 }
                 memset( pdwAdData, 0, dwNumData * sizeof( int ) );
                 if ( false == Asb3000w->GetData( wDevNo, dwNumData, pdwAdData ) ) {
                     ErrorMessage( wDevNo );
                     return;
                 }
                 szbuf = String::Concat( "TvOf[^ ", dwNumData.ToString(), 
                                            " 擾܂B\n\n",
                                            "CH1 擾f[^\n" );
                 for ( i = 4990; i <= 5010; i++ ) {		// 擾f[^\
                     dwData = pdwAdData[ i ] & Asb3000::ADDATA_MASK_BIT;			// CH1
                     //dwData = (pdwAdData[ i ] >> 16) & Asb3000::ADDATA_MASK_BIT;	// CH2
                     dblData = VoltValue( dwData );
                     sztmp = String::Format( S"   {0} : {1} ({2})\n",
                                                i.ToString(), dwData.ToString(), dblData.ToString("f2") );
                     szbuf = String::Concat( szbuf, sztmp );
                 }
                 szbuf = String::Concat( szbuf,
                                         S"\n gKʒu : ", 
                                         mSetMode->dwTrigPos.ToString(), 
                                         S" ̑O10\\n",
                                         S"@@JbR͓dl(PmV)" );
                 ResultMessage( szbuf );
                 free( pdwAdData );
                 //----------------------------------------------------------
                 // I
                 //----------------------------------------------------------
                 this->Close();
             }

             //-------------------------------------------------------------------
             // dlZ
             //-------------------------------------------------------------------
	private: double VoltValue( int addata )
             {
                 int voltdiv;
                 double vfull;

                 // Volt/div
                 switch ( mSetMode->dwVoltDiv[ Asb3000::CH1 ] ) {
                     case Asb3000::VOLTDIV_0:
                         voltdiv = 10;
                         break;
                     case Asb3000::VOLTDIV_1:
                         voltdiv = 20;
                         break;
                     case Asb3000::VOLTDIV_2:
                         voltdiv = 50;
                         break;
                     case Asb3000::VOLTDIV_3:
                         voltdiv = 100;
                         break;
                     case Asb3000::VOLTDIV_4:
                         voltdiv = 200;
                         break;
                     case Asb3000::VOLTDIV_5:
                         voltdiv = 500;
                         break;
                     case Asb3000::VOLTDIV_6:
                         voltdiv = 1000;
                         break;
                     case Asb3000::VOLTDIV_7:
                         voltdiv = 2000;
                         break;
                     default: voltdiv = 0;
                 }
                 // tXP[d(v[u10:1)
                 vfull = voltdiv * Asb3000::PROBE_X10 * 10;
                 // dlɊZ
                 return ( ( vfull * addata / Asb3000::RES_VERT )
                                - ( vfull * mSetMode->dwVoltPos[ Asb3000::CH1 ] / Asb3000::RES_VOLTPOS ) );
             }

             //-------------------------------------------------------------------
             // `f[^擾pXbhG[
             //-------------------------------------------------------------------
	private: void DataThreadError( IntPtr wParam, IntPtr lParam )
			 {
                 if ( Asb3000::DEVICE_ID == lParam.ToInt32() ) {
                     ErrorMessage( (short)wParam.ToInt32() );
                 }
			 }

             //-------------------------------------------------------------------
             // ʂ\
             //-------------------------------------------------------------------
	private: void ResultMessage(String* pstrbuf)
             {
                 MessageBox::Show( pstrbuf, this->Text,
                                    MessageBoxButtons::OK, MessageBoxIcon::Information );
			 }

             //-------------------------------------------------------------------
             // G[bZ[W\
             //-------------------------------------------------------------------
	private: void ErrorMessage(short devno)
			 {
                 int dwRes = Asb3000w->GetLastError( devno );
                 String* strbuf;

                 strbuf = String::Concat( S"ASB-3000 error\n\n",
                                            String::Format(S"Error code: 0x{0}", dwRes.ToString("x8")) );
                 MessageBox::Show( strbuf, this->Text,
                                    MessageBoxButtons::OK, MessageBoxIcon::Stop );
             }
	};
}
