//===================================================================
// asb3000w.h
//-------------------------------------------------------------------
//
// ASB-3000 Wrapper
//
//===================================================================
#pragma once

#include <windows.h>

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;
using namespace System::Threading;
using namespace System::Runtime::InteropServices;

// NX̐錾
__gc public class Asb3000;

__gc public class Asb3000
{
public:
	//-----------------------------------------------------------------
	// foCXANZXɊւ`
	//-----------------------------------------------------------------
	static const int	MAX_DEVICE				= 16;			// őfoCX
	static const int	DEVICE_AUTO				= -1;			// foCXw
	//-----------------------------------------------------------------
	// `lɊւ`
	//-----------------------------------------------------------------
	static const int	NUM_CH					= 2;			// Ή`l
	static const int	CH1						= 0;			// CH1
	static const int	CH2						= 1;			// CH2
	//-----------------------------------------------------------------
	// foCXɊւ`
	//-----------------------------------------------------------------
	static const int	VID_LENGTH				= 8;			// x_ʕ
	static const int	PID_LENGTH				= 16;			// v_Ngʕ
	//-----------------------------------------------------------------
	// TvOXe[^X̒`
	//-----------------------------------------------------------------
	static const int	STS_STOP				= 0x0;			// CxgȂ(~)
	static const int	STS_PRE_TRIG			= 0x1;			// gK҂ɂȂȌ
	static const int	STS_WAIT_FOR_TRIG		= 0x3;			// gK҂̏
	static const int	STS_TRIG_DETECT			= 0x7;			// gK|
	static const int	STS_AUTO_RUN			= 0xB;			// ^CAEgt[ōăX^[g
	//-----------------------------------------------------------------
	// G[R[h̒`
	//-----------------------------------------------------------------
	static const int	SUCCESS					= 0;			// ُȂ
	static const int	ERR_SYSTEM				= 1;			// VXeG[
	static const int	ERR_NO_DEVICE			= 2;			// gp\ȃfoCX܂
	static const int	ERR_IN_USE				= 3;			// w̃foCX͎gpł
	static const int	ERR_INVALID_DEVICENO	= 4;			// sȃfoCXʔԍł
	static const int	ERR_INVALID_ARGUMENT	= 5;			// sȈw肳܂
	static const int	ERR_INTERNAL			= 6;			// G[ł
	static const int	ERR_TRANSFER_TIMEOUT	= 7;			// f[^]^CAEgɂȂ܂
	static const int	ERR_TRANSFER_CANCEL		= 8;			// f[^]LZ܂
	static const int	ERR_TRANSFER_FAIL		= 9;			// f[^]s܂
	static const int	ERR_BUFF_OVERFLOW		= 10;			// obt@I[o[t[ł
	static const int	ERR_MEMSIZE				= 11;			// 擾TCYُł
	static const int	ERR_DEVICE				= 12;			// foCXG[ł
	//-----------------------------------------------------------------
	// bZ[W̒`
	//-----------------------------------------------------------------
	static const int	WM_DATA_READY			= 1;			// `f[^
	static const int	WM_DATA_THREAD_ERROR	= 2;			// f[^擾pXbhG[
	//-----------------------------------------------------------------
	// ̑̒`
	//-----------------------------------------------------------------
	static const int	DEVICE_ID				= 0xAB00;		// foCXID
	static const int	RES_VERT				= 1024;			// \(1024|Cg)
	static const int	RES_VOLTPOS				= 500;			// d|WV\
	static const int	ADBUFF_MAX_SIZE			= 1000000;		// ݍőf[^
	static const int	ADDATA_MASK_BIT			= 0x000003FF;	// rbg}XN
	//-----------------------------------------------------------------
	// eݒl̒`
	//-----------------------------------------------------------------
	// (d)XP[
	static const int	VOLTDIV_0				= 0;			// 10mV  or 100mV
	static const int	VOLTDIV_1				= 1;			// 20mV  or 200mV
	static const int	VOLTDIV_2				= 2;			// 50mV  or 500mV
	static const int	VOLTDIV_3				= 3;			// 100mV or 1V
	static const int	VOLTDIV_4				= 4;			// 200mV or 2V
	static const int	VOLTDIV_5				= 5;			// 500mV or 5V
	static const int	VOLTDIV_6				= 6;			// 1V    or 10V
	static const int	VOLTDIV_7				= 7;			// 2V    or 20V
	// v[u
	static const int	PROBE_X1				= 1;			// 1:1
	static const int	PROBE_X10				= 10;			// 10:1
	static const int	PROBE_X100				= 100;			// 100:1
	// ͌
	static const int	CUP_DC					= 0;			// DC
	static const int	CUP_AC					= 1;			// AC
	// TCY
	static const int	MEMSIZE_10K				= 0;			// 10kPoint
	static const int	MEMSIZE_100K			= 1;			// 100kPoint
	static const int	MEMSIZE_1M				= 2;			// 1MPoint
	// ()XP[
	static const int	TIMEDIV_10NS			= 10;			// 10ns
	static const int	TIMEDIV_20NS			= 20;			// 20ns
	static const int	TIMEDIV_50NS			= 50;			// 50ns
	static const int	TIMEDIV_100NS			= 100;			// 100ns
	static const int	TIMEDIV_200NS			= 200;			// 200ns
	static const int	TIMEDIV_500NS			= 500;			// 500ns
	static const int	TIMEDIV_1US				= 1000;			// 1us
	static const int	TIMEDIV_2US				= 2000;			// 2us
	static const int	TIMEDIV_5US				= 5000;			// 5us
	static const int	TIMEDIV_10US			= 10000;		// 10us
	static const int	TIMEDIV_20US			= 20000;		// 20us
	static const int	TIMEDIV_50US			= 50000;		// 50us
	static const int	TIMEDIV_100US			= 100000;		// 100us
	static const int	TIMEDIV_200US			= 200000;		// 200us
	static const int	TIMEDIV_500US			= 500000;		// 500us
	static const int	TIMEDIV_1MS				= 1000000;		// 1ms
	static const int	TIMEDIV_2MS				= 2000000;		// 2ms
	static const int	TIMEDIV_5MS				= 5000000;		// 5ms
	static const int	TIMEDIV_10MS			= 10000000;		// 10ms
	// gш
	static const int	BW_FULL					= 0;			// FULL
	static const int	BW_20MHZ				= 1;			// 20MHz
	// TvO[h
	static const int	SMP_REAL				= 0;			// ATvO
	static const int	SMP_EQU					= 1;			// TvO
	// ANCWV[h
	static const int	ACQ_SINGLE				= 0;			// VOVbg
	static const int	ACQ_ROLL				= 1;			// [
	// gK[h
	static const int	TMODE_AUTO				= 0;			// I[g
	static const int	TMODE_NORMAL			= 1;			// m[}
	static const int	TMODE_FREERUN			= 2;			// t[
	// gK\[X
	static const int	TSRC_CH1				= 0;			// CH1
	static const int	TSRC_CH2				= 1;			// CH2
	static const int	TSRC_EXT				= 2;			// O
	// gK͌
	static const int	TCUP_DC					= 0;			// DC
	static const int	TCUP_LF					= 1;			// LFrej
	static const int	TCUP_HF					= 2;			// HFrej
	// gKX[v
	static const int	TSLP_POS				= 0;			// (オ)
	static const int	TSLP_NEG				= 1;			// ()
	// pXgK(pX)
	static const int	PULSE_NONE				= 0;			// gp
	static const int	PULSE_UNDER				= 1;			// pX
	static const int	PULSE_ABOVE				= 2;			// pXȏ

  //-----------------------------------------------------------------
  // foCX\
  //-----------------------------------------------------------------
	[StructLayout(LayoutKind::Sequential)]
	__gc class TDEVINFO
	{
	public:
		// x_ʕ
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Asb3000::VID_LENGTH)]
		Byte	VendorID[];
		// v_Ngʕ
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Asb3000::PID_LENGTH)]
		Byte	ProductID[];
		// t@[EFÃo[W
		Byte	FirmVer;
		// FPGÃo[W
		Byte	FpgaVer;
	};
	//-----------------------------------------------------------------
	// TvOp[^\
	//-----------------------------------------------------------------
	[StructLayout(LayoutKind::Sequential)]
	__gc class TSETMODE
	{
	public:
		// ݒ
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Asb3000::NUM_CH)]
		Int32	dwVoltDiv[];					// (d)XP[
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Asb3000::NUM_CH)]
		Int32	dwVoltPos[];					// (d)|WV
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Asb3000::NUM_CH)]
		Int32	dwVertCoupling[];				// (d)͌
	
		// ݒ
		Int32	dwMemSize;						// TCY
		Int32	dwSamplingTime;					// ()XP[
		[MarshalAs(UnmanagedType::ByValArray, SizeConst=Asb3000::NUM_CH)]
		Int32	dwBandWidth[];					// gш
		Int32	dwSamplingMode;					// TvO[h
		Int32	dwAcqMode;						// ANCWV[h

		// gKݒ
		Int32	dwTrigMode;						// gK[h
		Int32	dwTrigSource;					// gK\[X
		Int32	dwTrigCoupling;					// gK͌
		Int32	dwTrigSlope;					// gKX[v
		Int32	dwTrigLevel;					// gKx
		Int32	dwTrigPos;						// gK|WV
		Int32	dwTrigDelay;					// gKfBC
		Int32	dwTrigPulse;					// pXgK(pX)
		Int32	dwTrigPulseWidth;				// pXgK(pX)
	};

	//-------------------------------------------------------------------
	// API
	//-------------------------------------------------------------------
	// o[W擾
	[DllImport("asb3000.dll")]
	static bool Asb3000GetVersion(int* pdwDrvVer, int* pdwDllVer);
	
	// foCX̌
	[DllImport("asb3000.dll")]
	static bool Asb3000Create(short* pwDeviceNo, int hWnd, short uWMBase);
	
	// foCX̊J
	[DllImport("asb3000.dll")]
	static bool Asb3000Close(int wDeviceNo);
	
	// foCX擾
	[DllImport("asb3000.dll")]
	static bool Asb3000GetDevInfo(short wDeviceNo, [In][Out] TDEVINFO* pDevInfo);
	
	// TCY擾
	[DllImport("asb3000.dll")]
	static bool Asb3000GetMemSize(short wDeviceNo, int* pdwMemSize);
	
	// TvO샂[h̐ݒ
	[DllImport("asb3000.dll")]
	static bool Asb3000SetMode(short wDeviceNo, [In][Out] TSETMODE* pSetMode);
	
	// TvOJn
	[DllImport("asb3000.dll")]
	static bool Asb3000StartSampling(short wDeviceNo, int dwInitArg);
	
	// TvO~
	[DllImport("asb3000.dll")]
	static bool Asb3000StopSampling(short wDeviceNo);
	
	// TvOXe[^X擾
	[DllImport("asb3000.dll")]
	static bool Asb3000GetStatus(short wDeviceNo, int* pdwStatus,
									int* pdwNumData, int* pvInitArg);
	
	// TvOf[^擾
	[DllImport("asb3000.dll")]
	static bool Asb3000GetData(short wDeviceNo, int dwNumData, int* pData);
	
	// G[R[h
	[DllImport("asb3000.dll")]
	static int Asb3000GetLastError(short wDeviceNo);


	//-------------------------------------------------------------------
	// 		o[W擾
	// 		pdwDrvVer	hCõo[Wi[̈ւ̃|C^
	//			pdwDllVer	DLL̃o[Wi[̈ւ̃|C^
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool GetVersion(int* pdwDrvVer, int* pdwDllVer)
	{
		return Asb3000GetVersion(pdwDrvVer, pdwDllVer);
	}
	//-------------------------------------------------------------------
	// 		foCX̌
	// 		pwDeviceNo	gpfoCX̃foCXʔԍi[̈ւ
	//						|C^
	//			hWnd		DLLo郁bZ[W󂯎EBhẼnh
	//			uWMBase		o郁bZ[WID̃x[Xl
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool Create(short* pwDeviceNo, int hWnd, short uWMBase)
	{
		return Asb3000Create(pwDeviceNo, hWnd, uWMBase);
	}
	//-------------------------------------------------------------------
	// 		foCX̊J
	// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool Close(short wDeviceNo)
	{
		return Asb3000Close(wDeviceNo);
	}
	//-------------------------------------------------------------------
	// 		foCX̎擾
	// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
	//			pDevInfo	foCXi[\̂ւ̃|C^
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool GetDevInfo(short wDeviceNo, [In][Out] TDEVINFO* pDevInfo)
	{
		return Asb3000GetDevInfo(wDeviceNo, pDevInfo);
	}
	//-------------------------------------------------------------------
	// 		TCY̎擾
	// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
	//			pdwMemSize	Ă郁TCYi[̈ւ̃|C^
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool GetMemSize(short wDeviceNo, int* pdwMemSize)
	{
		return Asb3000GetMemSize(wDeviceNo, pdwMemSize);
	}
	//-------------------------------------------------------------------
	// 		TvO샂[h̐ݒ
	// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
	//			pSetMode	TvOp[^̃|C^
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool SetMode(short wDeviceNo, [In][Out] TSETMODE* pSetMode)
	{
		return Asb3000SetMode(wDeviceNo, pSetMode);
	}
	//-------------------------------------------------------------------
	// 		TvO̊Jn
	// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
	//			dwInitArg	\(0w)
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool StartSampling(short wDeviceNo, int dwInitArg)
	{
		return Asb3000StartSampling(wDeviceNo, dwInitArg);
	}
	//-------------------------------------------------------------------
	// 		TvO̒~
	// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool StopSampling(short wDeviceNo)
	{
		return Asb3000StopSampling(wDeviceNo);
	}
	//-------------------------------------------------------------------
	// 		TvOXe[^X擾
	// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
	//			pdwStatus	TvOXe[^X
	//			pdwNumData	ǃTvOf[^
	//			pvInitArg	\
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool GetStatus(short wDeviceNo, int* pdwStatus, 
							int* pdwNumData, int* pvInitArg)
	{
		return Asb3000GetStatus(wDeviceNo, pdwStatus, pdwNumData, pvInitArg);
	}
	//-------------------------------------------------------------------
	// 		TvOf[^擾
	// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
	//			dwNumData	擾f[^
	//			pdwData		擾f[^i[̈ւ̃|C^
	// ߂l	 True
	//			s False
	//-------------------------------------------------------------------
	static bool GetData(short wDeviceNo, int dwNumData, int* pData)
	{
		return Asb3000GetData(wDeviceNo, dwNumData, pData);
	}
	//-------------------------------------------------------------------
	// 		G[R[h̎擾
	// 		wDeviceNo	ΏۃfoCX̃foCXʔԍ
	// ߂l	G[R[h
	//-------------------------------------------------------------------
	static int GetLastError(short wDeviceNo)
	{
		return Asb3000GetLastError(wDeviceNo);
	}

};
