Attribute VB_Name = "Wrapper"
'====================================================================
' asb3000w.bas
'--------------------------------------------------------------------
'
' ASB-3000 Wrapper
'
'====================================================================
Option Explicit

Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const ASB3000_DLL_NAME = "asb3000.dll"   ' DLLt@C
Global Const ASB3000_ERR_WRAPDLL = -1           ' bp[֐G[

Dim hDLL As Long                                ' DLL nh

'--------------------------------------------------------------------
'       DLL[h(񃍁[h̓G[Ƃ)
'       
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wDllOpen() As Boolean
    
    Asb3000wDllOpen = False
    
    If hDLL <> 0 Then Exit Function
    
    hDLL = LoadLibrary(ASB3000_DLL_NAME)
    If hDLL = 0 Then Exit Function
    
    If Asb3000wGetDllExportFunc() = False Then
        Asb3000wDllClose    ' DLLGNX|[g֐擾ɎŝDLLN[Y
        Exit Function
    End If
    
    Asb3000wDllOpen = True
    
End Function
'--------------------------------------------------------------------
'       DLLA[h(A[h̓G[Ƃ)
'       
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wDllClose() As Boolean
    
    Asb3000wDllClose = True
    
    If hDLL = 0 Then Exit Function
    
    If FreeLibrary(hDLL) <> 0 Then hDLL = 0 Else Asb3000wDllClose = False
    
End Function
'--------------------------------------------------------------------
'       o[W擾
'       pdwDrvVer   hCõo[Wi[̈ւ̃|C^
'           pdwDllVer   DLL̃o[Wi[̈ւ̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wGetVersion(ByRef pdwDrvVer As Long, ByRef pdwDllVer As Long) As Boolean

    Asb3000wGetVersion = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000GetVersion(pdwDrvVer, pdwDllVer) = 0 Then Exit Function
    
    Asb3000wGetVersion = True
    
End Function
'--------------------------------------------------------------------
'       foCX̌
'       pwDeviceNo  gpfoCX̃foCXʔԍi[̈ւ
'                       |C^
'           hWnd        DLLo郁bZ[W󂯎EBhẼnh
'           uWMBase     o郁bZ[WID̃x[Xl
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wCreate(ByRef pwDeviceNo As Integer, ByVal hWnd As Long, ByVal uWMBase As Long) As Boolean

    Asb3000wCreate = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000Create(pwDeviceNo, hWnd, uWMBase) = 0 Then Exit Function
    
    Asb3000wCreate = True
    
End Function
'-------------------------------------------------------------------
'       foCX̊J
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
' ߂l     True
'           s False
'-------------------------------------------------------------------
Function Asb3000wClose(ByVal wDeviceNo As Integer) As Boolean

    Asb3000wClose = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000Close(wDeviceNo) = 0 Then Exit Function
    
    Asb3000wClose = True
    
End Function
'--------------------------------------------------------------------
'       foCX̎擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           pDevInfo    foCXi[\̂ւ̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wGetDevInfo(ByVal wDeviceNo As Integer, ByRef pDevInfo As TDEVINFO) As Boolean

    Asb3000wGetDevInfo = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000GetDevInfo(wDeviceNo, pDevInfo) = 0 Then Exit Function
    
    Asb3000wGetDevInfo = True
    
End Function
'--------------------------------------------------------------------
'       TCY̎擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           pdwMemSize  Ă郁TCYi[̈ւ̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wGetMemSize(ByVal wDeviceNo As Integer, ByRef pdwMemSize As Long) As Boolean

    Asb3000wGetMemSize = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000GetMemSize(wDeviceNo, pdwMemSize) = 0 Then Exit Function
    
    Asb3000wGetMemSize = True
    
End Function
'--------------------------------------------------------------------
'       TvO샂[h̐ݒ
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           pSetMode    ݒi[Ă\̂̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wSetMode(ByVal wDeviceNo As Integer, ByRef pSetMode As TSETMODE) As Boolean

    Asb3000wSetMode = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000SetMode(wDeviceNo, pSetMode) = 0 Then Exit Function
    
    Asb3000wSetMode = True
    
End Function
'--------------------------------------------------------------------
'       TvO̊Jn
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           dwInitArg   \(0w)
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wStartSampling(ByVal wDeviceNo As Integer, ByVal dwInitArg As Long) As Boolean
    
    Asb3000wStartSampling = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000StartSampling(wDeviceNo, dwInitArg) = 0 Then Exit Function
    
    Asb3000wStartSampling = True
    
End Function
'--------------------------------------------------------------------
'       TvO̒~
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wStopSampling(ByVal wDeviceNo As Integer) As Boolean

    Asb3000wStopSampling = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000StopSampling(wDeviceNo) = 0 Then Exit Function
    
    Asb3000wStopSampling = True
    
End Function
'--------------------------------------------------------------------
'       TvOXe[^X擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           pdwStatus   TvOXe[^X
'           pdwNumData  ǃTvOf[^
'           pvInitArg   \
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wGetStatus(ByVal wDeviceNo As Integer, ByRef pdwStatus As Long, ByRef pdwNumData As Long, ByRef pvInitArg As Long) As Boolean

    Asb3000wGetStatus = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000GetStatus(wDeviceNo, pdwStatus, pdwNumData, pvInitArg) = 0 Then Exit Function
    
    Asb3000wGetStatus = True
    
End Function
'--------------------------------------------------------------------
'       TvOf[^擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
'           dwNumData   擾f[^
'           pdwData     擾f[^i[̈ւ̃|C^
' ߂l     True
'           s False
'--------------------------------------------------------------------
Function Asb3000wGetData(ByVal wDeviceNo As Integer, ByVal dwNumData As Long, ByRef pdwData() As Long) As Boolean

    Asb3000wGetData = False
    
    If hDLL = 0 Then Exit Function
    
    If Asb3000GetData(wDeviceNo, dwNumData, pdwData(LBound(pdwData))) = 0 Then Exit Function
    
    Asb3000wGetData = True
    
End Function
'--------------------------------------------------------------------
'       G[R[h̎擾
'       wDeviceNo   ΏۃfoCX̃foCXʔԍ
' ߂l    G[R[h
'--------------------------------------------------------------------
Function Asb3000wGetLastError(ByVal wDeviceNo As Integer) As Long

    Asb3000wGetLastError = ASB3000_ERR_WRAPDLL
    
    If hDLL = 0 Then Exit Function
    
    Asb3000wGetLastError = Asb3000GetLastError(wDeviceNo)
    
End Function

'--------------------------------------------------------------------
'       DLLGNX|[g֐AhX̎擾
'       
' ߂l     True
'           s False
'--------------------------------------------------------------------
Private Function Asb3000wGetDllExportFunc() As Boolean

    Dim pFunc As Long
    
    Asb3000wGetDllExportFunc = False
    
    ' Asb3000GetVersioñAhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000GetVersion")
    If pFunc = 0 Then Exit Function
    ' Asb3000CreatẽAhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000Create")
    If pFunc = 0 Then Exit Function
    ' Asb3000ClosẽAhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000Close")
    If pFunc = 0 Then Exit Function
    ' Asb3000GetDevInfõAhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000GetDevInfo")
    If pFunc = 0 Then Exit Function
    ' Asb3000GetMemSizẽAhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000GetMemSize")
    If pFunc = 0 Then Exit Function
    ' Asb3000SetModẽAhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000SetMode")
    If pFunc = 0 Then Exit Function
    ' Asb3000StartSampling̃AhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000StartSampling")
    If pFunc = 0 Then Exit Function
    ' Asb3000StopSampling̃AhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000StopSampling")
    If pFunc = 0 Then Exit Function
    ' Asb3000GetStatus̃AhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000GetStatus")
    If pFunc = 0 Then Exit Function
    ' Asb3000GetDatãAhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000GetData")
    If pFunc = 0 Then Exit Function
    ' Asb3000GetLastError̃AhX擾
    pFunc = GetProcAddress(hDLL, "Asb3000GetLastError")
    If pFunc = 0 Then Exit Function
    
    Asb3000wGetDllExportFunc = True ' SĂDLLGNX|[g֐AhX擾
End Function

